diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/model/packet-metadata.cc ns-3.41/src/network/model/packet-metadata.cc
--- ns-3.40/src/network/model/packet-metadata.cc	2023-09-27 13:30:37.854839600 -0700
+++ ns-3.41/src/network/model/packet-metadata.cc	2024-02-09 14:44:08.401793700 -0800
@@ -493,7 +493,7 @@
         AppendValue(extraItem->fragmentEnd, buffer);
         buffer += fragEndSize;
         Append32(extraItem->packetUid, buffer);
-        m_used = std::max(m_used, (uint16_t)(buffer - &m_data->m_data[0]));
+        m_used = std::max(m_used, static_cast<uint32_t>(buffer - &m_data->m_data[0]));
         m_data->m_dirtyEnd = m_used;
         return;
     }
@@ -1329,7 +1329,7 @@
 {
     NS_LOG_FUNCTION(static_cast<uint32_t>(data) << &start << &current << maxSize);
     // First check buffer overflow
-    if (static_cast<uint32_t>((current + sizeof(uint8_t) - start)) > maxSize)
+    if (static_cast<uint32_t>(current + sizeof(uint8_t) - start) > maxSize)
     {
         return nullptr;
     }
@@ -1345,7 +1345,7 @@
 {
     NS_LOG_FUNCTION(data << &start << &current << maxSize);
     // First check buffer overflow
-    if (static_cast<uint32_t>((current + sizeof(uint16_t) - start)) > maxSize)
+    if (static_cast<uint32_t>(current + sizeof(uint16_t) - start) > maxSize)
     {
         return nullptr;
     }
@@ -1361,7 +1361,7 @@
 {
     NS_LOG_FUNCTION(data << &start << &current << maxSize);
     // First check buffer overflow
-    if (static_cast<uint32_t>((current + sizeof(uint32_t) - start)) > maxSize)
+    if (static_cast<uint32_t>(current + sizeof(uint32_t) - start) > maxSize)
     {
         return nullptr;
     }
@@ -1377,7 +1377,7 @@
 {
     NS_LOG_FUNCTION(data << &start << &current << maxSize);
     // First check buffer overflow
-    if (static_cast<uint32_t>((current + sizeof(uint64_t) - start)) > maxSize)
+    if (static_cast<uint32_t>(current + sizeof(uint64_t) - start) > maxSize)
     {
         return nullptr;
     }
@@ -1394,7 +1394,7 @@
 {
     NS_LOG_FUNCTION(&data << dataSize << &start << &current << maxSize);
     // First check buffer overflow
-    if (static_cast<uint32_t>((current + dataSize - start)) > maxSize)
+    if (static_cast<uint32_t>(current + dataSize - start) > maxSize)
     {
         return nullptr;
     }
@@ -1410,7 +1410,7 @@
 {
     NS_LOG_FUNCTION(static_cast<uint32_t>(data) << &start << &current << maxSize);
     // First check buffer underflow
-    if (static_cast<uint32_t>((current + sizeof(uint8_t) - start)) > maxSize)
+    if (static_cast<uint32_t>(current + sizeof(uint8_t) - start) > maxSize)
     {
         return nullptr;
     }
@@ -1426,7 +1426,7 @@
 {
     NS_LOG_FUNCTION(data << &start << &current << maxSize);
     // First check buffer underflow
-    if (static_cast<uint32_t>((current + sizeof(uint16_t) - start)) > maxSize)
+    if (static_cast<uint32_t>(current + sizeof(uint16_t) - start) > maxSize)
     {
         return nullptr;
     }
@@ -1442,7 +1442,7 @@
 {
     NS_LOG_FUNCTION(data << &start << &current << maxSize);
     // First check buffer underflow
-    if (static_cast<uint32_t>((current + sizeof(uint32_t) - start)) > maxSize)
+    if (static_cast<uint32_t>(current + sizeof(uint32_t) - start) > maxSize)
     {
         return nullptr;
     }
@@ -1458,7 +1458,7 @@
 {
     NS_LOG_FUNCTION(data << &start << &current << maxSize);
     // First check buffer underflow
-    if ((uint32_t)((current + sizeof(uint64_t) - start)) > maxSize)
+    if ((uint32_t)(current + sizeof(uint64_t) - start) > maxSize)
     {
         return nullptr;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/model/packet-metadata.h ns-3.41/src/network/model/packet-metadata.h
--- ns-3.40/src/network/model/packet-metadata.h	2023-09-27 13:30:37.854839600 -0700
+++ ns-3.41/src/network/model/packet-metadata.h	2024-02-09 14:44:08.421793700 -0800
@@ -428,7 +428,7 @@
         /** number of references to this struct Data instance. */
         uint32_t m_count;
         /** size (in bytes) of m_data buffer below */
-        uint16_t m_size;
+        uint32_t m_size;
         /** max of the m_used field over all objects which reference this struct Data instance */
         uint16_t m_dirtyEnd;
         /** variable-sized buffer of bytes */
@@ -697,7 +697,7 @@
      */
     uint16_t m_head;      //!< list head
     uint16_t m_tail;      //!< list tail
-    uint16_t m_used;      //!< used portion
+    uint32_t m_used;      //!< used portion
     uint64_t m_packetUid; //!< packet Uid
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/model/packet-tag-list.cc ns-3.41/src/network/model/packet-tag-list.cc
--- ns-3.40/src/network/model/packet-tag-list.cc	2023-09-27 13:30:37.854839600 -0700
+++ ns-3.41/src/network/model/packet-tag-list.cc	2024-02-09 14:44:08.421793700 -0800
@@ -266,7 +266,8 @@
     for (TagData* cur = m_next; cur != nullptr; cur = cur->next)
     {
         NS_ASSERT_MSG(cur->tid != tag.GetInstanceTypeId(),
-                      "Error: cannot add the same kind of tag twice.");
+                      "Error: cannot add the same kind of tag twice. The tag type is "
+                          << tag.GetInstanceTypeId().GetName());
     }
     TagData* head = CreateTagData(tag.GetSerializedSize());
     head->count = 1;
@@ -335,60 +336,54 @@
     uint32_t* p = buffer;
     uint32_t size = 0;
 
-    uint32_t* numberOfTags = nullptr;
+    size += 4;
 
-    if (size + 4 <= maxSize)
-    {
-        numberOfTags = p;
-        *p++ = 0;
-        size += 4;
-    }
-    else
+    if (size > maxSize)
     {
         return 0;
     }
 
+    uint32_t* numberOfTags = p;
+    *p++ = 0;
+
     for (TagData* cur = m_next; cur != nullptr; cur = cur->next)
     {
-        if (size + 4 <= maxSize)
-        {
-            *p++ = cur->size;
-            size += 4;
-        }
-        else
+        size += 4;
+
+        if (size > maxSize)
         {
             return 0;
         }
 
+        *p++ = cur->size;
+
         NS_LOG_INFO("Serializing tag id " << cur->tid);
 
         // ensure size is multiple of 4 bytes for 4 byte boundaries
         uint32_t hashSize = (sizeof(TypeId::hash_t) + 3) & (~3);
-        if (size + hashSize <= maxSize)
-        {
-            TypeId::hash_t tid = cur->tid.GetHash();
-            memcpy(p, &tid, sizeof(TypeId::hash_t));
-            p += hashSize / 4;
-            size += hashSize;
-        }
-        else
+        size += hashSize;
+
+        if (size > maxSize)
         {
             return 0;
         }
 
+        TypeId::hash_t tid = cur->tid.GetHash();
+        memcpy(p, &tid, sizeof(TypeId::hash_t));
+        p += hashSize / 4;
+
         // ensure size is multiple of 4 bytes for 4 byte boundaries
         uint32_t tagWordSize = (cur->size + 3) & (~3);
-        if (size + tagWordSize <= maxSize)
-        {
-            memcpy(p, cur->data, cur->size);
-            size += tagWordSize;
-            p += tagWordSize / 4;
-        }
-        else
+        size += tagWordSize;
+
+        if (size > maxSize)
         {
             return 0;
         }
 
+        memcpy(p, cur->data, cur->size);
+        p += tagWordSize / 4;
+
         (*numberOfTags)++;
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/model/socket.cc ns-3.41/src/network/model/socket.cc
--- ns-3.40/src/network/model/socket.cc	2023-09-27 13:30:37.854839600 -0700
+++ ns-3.41/src/network/model/socket.cc	2024-02-09 14:44:08.421793700 -0800
@@ -73,9 +73,11 @@
 {
     NS_LOG_FUNCTION(node << tid);
     Ptr<Socket> s;
-    NS_ASSERT(node);
+    NS_ASSERT_MSG(node, "CreateSocket: node is null.");
     Ptr<SocketFactory> socketFactory = node->GetObject<SocketFactory>(tid);
-    NS_ASSERT(socketFactory);
+    NS_ASSERT_MSG(socketFactory,
+                  "CreateSocket: can not create a "
+                      << tid.GetName() << " - perhaps the node is missing the required protocol.");
     s = socketFactory->CreateSocket();
     NS_ASSERT(s);
     return s;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/test/packet-test-suite.cc ns-3.41/src/network/test/packet-test-suite.cc
--- ns-3.40/src/network/test/packet-test-suite.cc	2023-09-27 13:30:37.854839600 -0700
+++ ns-3.41/src/network/test/packet-test-suite.cc	2024-02-09 14:44:08.421793700 -0800
@@ -1110,13 +1110,15 @@
     ref.Add(t6);       // pre-merge
     ref.Add(t7);       // first
 
-    { // Peek
+    // Peek
+    {
         std::cout << GetName() << "check Peek (missing tag) returns false" << std::endl;
         ATestTag<10> t10;
         NS_TEST_EXPECT_MSG_EQ(ref.Peek(t10), false, "missing tag");
     }
 
-    { // Copy ctor, assignment
+    // Copy ctor, assignment
+    {
         std::cout << GetName() << "check copy and assignment" << std::endl;
         {
             // Test copy constructor
@@ -1134,55 +1136,56 @@
         }
     }
 
-    {// Removal
+    // Removal
+    {
 #define RemoveCheck(n)                                                                             \
-    {                                                                                              \
-        PacketTagList p##n = ref;                                                                  \
-        p##n.Remove(t##n);                                                                         \
-        CheckRefList(ref, "remove " #n " orig");                                                   \
-        CheckRefList(p##n, "remove " #n " copy", n);                                               \
-    }
+    PacketTagList p##n = ref;                                                                      \
+    p##n.Remove(t##n);                                                                             \
+    CheckRefList(ref, "remove " #n " orig");                                                       \
+    CheckRefList(p##n, "remove " #n " copy", n);
 
-     {// Remove single tags from list
-      std::cout << GetName() << "check removal of each tag" << std::endl;
-    RemoveCheck(1);
-    RemoveCheck(2);
-    RemoveCheck(3);
-    RemoveCheck(4);
-    RemoveCheck(5);
-    RemoveCheck(6);
-    RemoveCheck(7);
-}
+        // Remove single tags from list
+        {
+            std::cout << GetName() << "check removal of each tag" << std::endl;
+            RemoveCheck(1);
+            RemoveCheck(2);
+            RemoveCheck(3);
+            RemoveCheck(4);
+            RemoveCheck(5);
+            RemoveCheck(6);
+            RemoveCheck(7);
+        }
 
-{ // Remove in the presence of a merge
-    std::cout << GetName() << "check removal doesn't disturb merge " << std::endl;
-    PacketTagList ptl = ref;
-    ptl.Remove(t7);
-    ptl.Remove(t6);
-    ptl.Remove(t5);
-
-    PacketTagList mrg = ptl; // merged list
-    ATestTag<8> m5(1);
-    mrg.Add(m5); // ptl and mrg differ
-    ptl.Add(t5);
-    ptl.Add(t6);
-    ptl.Add(t7);
-
-    CheckRefList(ref, "post merge, orig");
-    CheckRefList(ptl, "post merge, long chain");
-    const char* msg = "post merge, short chain";
-    CheckRef(mrg, t1, msg, false);
-    CheckRef(mrg, t2, msg, false);
-    CheckRef(mrg, t3, msg, false);
-    CheckRef(mrg, t4, msg, false);
-    CheckRef(mrg, m5, msg, false);
-}
+        // Remove in the presence of a merge
+        {
+            std::cout << GetName() << "check removal doesn't disturb merge " << std::endl;
+            PacketTagList ptl = ref;
+            ptl.Remove(t7);
+            ptl.Remove(t6);
+            ptl.Remove(t5);
+
+            PacketTagList mrg = ptl; // merged list
+            ATestTag<8> m5(1);
+            mrg.Add(m5); // ptl and mrg differ
+            ptl.Add(t5);
+            ptl.Add(t6);
+            ptl.Add(t7);
+
+            CheckRefList(ref, "post merge, orig");
+            CheckRefList(ptl, "post merge, long chain");
+            const char* msg = "post merge, short chain";
+            CheckRef(mrg, t1, msg, false);
+            CheckRef(mrg, t2, msg, false);
+            CheckRef(mrg, t3, msg, false);
+            CheckRef(mrg, t4, msg, false);
+            CheckRef(mrg, m5, msg, false);
+        }
 #undef RemoveCheck
-} // Removal
-
-{ // Replace
+    } // Removal
 
-    std::cout << GetName() << "check replacing each tag" << std::endl;
+    // Replace
+    {
+        std::cout << GetName() << "check replacing each tag" << std::endl;
 
 #define ReplaceCheck(n)                                                                            \
     t##n.m_data = 2;                                                                               \
@@ -1193,75 +1196,76 @@
         CheckRef(p##n, t##n, "replace " #n " copy");                                               \
     }
 
-    ReplaceCheck(1);
-    ReplaceCheck(2);
-    ReplaceCheck(3);
-    ReplaceCheck(4);
-    ReplaceCheck(5);
-    ReplaceCheck(6);
-    ReplaceCheck(7);
-}
-
-{ // Timing
-    std::cout << GetName() << "add+remove timing" << std::endl;
-    int flm = std::numeric_limits<int>::max();
-    const int nIterations = 100;
-    for (int i = 0; i < nIterations; ++i)
-    {
-        int now = AddRemoveTime();
-        if (now < flm)
-        {
-            flm = now;
-        }
+        ReplaceCheck(1);
+        ReplaceCheck(2);
+        ReplaceCheck(3);
+        ReplaceCheck(4);
+        ReplaceCheck(5);
+        ReplaceCheck(6);
+        ReplaceCheck(7);
     }
-    std::cout << GetName() << "min add+remove time: " << std::setw(8) << flm << " ticks"
-              << std::endl;
 
-    std::cout << GetName() << "remove timing" << std::endl;
-    // tags numbered from 1, so add one for (unused) entry at 0
-    std::vector<int> rmn(TAG_LAST + 1, std::numeric_limits<int>::max());
-    for (int i = 0; i < nIterations; ++i)
+    // Timing
     {
-        for (int j = 1; j <= TAG_LAST; ++j)
+        std::cout << GetName() << "add+remove timing" << std::endl;
+        int flm = std::numeric_limits<int>::max();
+        const int nIterations = 100;
+        for (int i = 0; i < nIterations; ++i)
         {
-            int now = 0;
-            switch (j)
+            int now = AddRemoveTime();
+            if (now < flm)
             {
-            case 7:
-                now = RemoveTime(ref, t7);
-                break;
-            case 6:
-                now = RemoveTime(ref, t6);
-                break;
-            case 5:
-                now = RemoveTime(ref, t5);
-                break;
-            case 4:
-                now = RemoveTime(ref, t4);
-                break;
-            case 3:
-                now = RemoveTime(ref, t3);
-                break;
-            case 2:
-                now = RemoveTime(ref, t2);
-                break;
-            case 1:
-                now = RemoveTime(ref, t1);
-                break;
-            } // switch
+                flm = now;
+            }
+        }
+        std::cout << GetName() << "min add+remove time: " << std::setw(8) << flm << " ticks"
+                  << std::endl;
 
-            if (now < rmn[j])
+        std::cout << GetName() << "remove timing" << std::endl;
+        // tags numbered from 1, so add one for (unused) entry at 0
+        std::vector<int> rmn(TAG_LAST + 1, std::numeric_limits<int>::max());
+        for (int i = 0; i < nIterations; ++i)
+        {
+            for (int j = 1; j <= TAG_LAST; ++j)
             {
-                rmn[j] = now;
-            }
-        } // for tag j
-    }     // for iteration i
-    for (int j = TAG_LAST; j > 0; --j)
-    {
-        std::cout << GetName() << "min remove time: t" << j << ": " << std::setw(8) << rmn[j]
-                  << " ticks" << std::endl;
-    }
-} // Timing
+                int now = 0;
+                switch (j)
+                {
+                case 7:
+                    now = RemoveTime(ref, t7);
+                    break;
+                case 6:
+                    now = RemoveTime(ref, t6);
+                    break;
+                case 5:
+                    now = RemoveTime(ref, t5);
+                    break;
+                case 4:
+                    now = RemoveTime(ref, t4);
+                    break;
+                case 3:
+                    now = RemoveTime(ref, t3);
+                    break;
+                case 2:
+                    now = RemoveTime(ref, t2);
+                    break;
+                case 1:
+                    now = RemoveTime(ref, t1);
+                    break;
+                } // switch
+
+                if (now < rmn[j])
+                {
+                    rmn[j] = now;
+                }
+            } // for tag j
+        }     // for iteration i
+        for (int j = TAG_LAST; j > 0; --j)
+        {
+            std::cout << GetName() << "min remove time: t" << j << ": " << std::setw(8) << rmn[j]
+                      << " ticks" << std::endl;
+        }
+    } // Timing
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/data-rate.cc ns-3.41/src/network/utils/data-rate.cc
--- ns-3.40/src/network/utils/data-rate.cc	2023-09-27 13:30:37.854839600 -0700
+++ ns-3.41/src/network/utils/data-rate.cc	2024-02-09 14:44:08.425794000 -0800
@@ -228,7 +228,7 @@
 DataRate
 DataRate::operator*(double rhs) const
 {
-    return DataRate(((uint64_t)(m_bps * rhs)));
+    return DataRate((uint64_t)(m_bps * rhs));
 }
 
 DataRate&
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/error-model.cc ns-3.41/src/network/utils/error-model.cc
--- ns-3.40/src/network/utils/error-model.cc	2023-09-27 13:30:37.854839600 -0700
+++ ns-3.41/src/network/utils/error-model.cc	2024-02-09 14:44:08.425794000 -0800
@@ -160,7 +160,7 @@
             .AddAttribute("ErrorUnit",
                           "The error unit",
                           EnumValue(ERROR_UNIT_BYTE),
-                          MakeEnumAccessor(&RateErrorModel::m_unit),
+                          MakeEnumAccessor<ErrorUnit>(&RateErrorModel::m_unit),
                           MakeEnumChecker(ERROR_UNIT_BIT,
                                           "ERROR_UNIT_BIT",
                                           ERROR_UNIT_BYTE,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/ipv4-address.cc ns-3.41/src/network/utils/ipv4-address.cc
--- ns-3.40/src/network/utils/ipv4-address.cc	2023-09-27 13:30:37.854839600 -0700
+++ ns-3.41/src/network/utils/ipv4-address.cc	2024-02-09 14:44:08.425794000 -0800
@@ -248,7 +248,7 @@
 Ipv4Address::IsInitialized() const
 {
     NS_LOG_FUNCTION(this);
-    return (m_initialized);
+    return m_initialized;
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/ipv4-address.h ns-3.41/src/network/utils/ipv4-address.h
--- ns-3.40/src/network/utils/ipv4-address.h	2023-09-27 13:30:37.854839600 -0700
+++ ns-3.41/src/network/utils/ipv4-address.h	2024-02-09 14:44:08.425794000 -0800
@@ -377,19 +377,19 @@
 inline bool
 operator==(const Ipv4Address& a, const Ipv4Address& b)
 {
-    return (a.m_address == b.m_address);
+    return a.m_address == b.m_address;
 }
 
 inline bool
 operator!=(const Ipv4Address& a, const Ipv4Address& b)
 {
-    return (a.m_address != b.m_address);
+    return a.m_address != b.m_address;
 }
 
 inline bool
 operator<(const Ipv4Address& a, const Ipv4Address& b)
 {
-    return (a.m_address < b.m_address);
+    return a.m_address < b.m_address;
 }
 
 /**
@@ -414,13 +414,13 @@
 inline bool
 operator==(const Ipv4Mask& a, const Ipv4Mask& b)
 {
-    return (a.m_mask == b.m_mask);
+    return a.m_mask == b.m_mask;
 }
 
 inline bool
 operator!=(const Ipv4Mask& a, const Ipv4Mask& b)
 {
-    return (a.m_mask != b.m_mask);
+    return a.m_mask != b.m_mask;
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/ipv6-address.cc ns-3.41/src/network/utils/ipv6-address.cc
--- ns-3.40/src/network/utils/ipv6-address.cc	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/ipv6-address.cc	2024-02-09 14:44:08.425794000 -0800
@@ -260,7 +260,7 @@
         0x00,
     };
     addr.Serialize(&buf[12]);
-    return (Ipv6Address(buf));
+    return Ipv6Address(buf);
 }
 
 Ipv4Address
@@ -272,7 +272,7 @@
 
     Serialize(buf);
     v4Addr = Ipv4Address::Deserialize(&buf[12]);
-    return (v4Addr);
+    return v4Addr;
 }
 
 Ipv6Address
@@ -568,11 +568,7 @@
     NS_LOG_FUNCTION(this);
     static uint8_t v4MappedPrefix[12] =
         {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff};
-    if (memcmp(m_address, v4MappedPrefix, sizeof(v4MappedPrefix)) == 0)
-    {
-        return (true);
-    }
-    return (false);
+    return memcmp(m_address, v4MappedPrefix, sizeof(v4MappedPrefix)) == 0;
 }
 
 Ipv6Address
@@ -651,7 +647,7 @@
     Ipv6Address masked = CombinePrefix(prefix);
     Ipv6Address reference = Ipv6Address::GetOnes().CombinePrefix(prefix);
 
-    return (masked == reference);
+    return masked == reference;
 }
 
 bool
@@ -768,7 +764,7 @@
 Ipv6Address::IsInitialized() const
 {
     NS_LOG_FUNCTION(this);
-    return (m_initialized);
+    return m_initialized;
 }
 
 std::ostream&
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/ipv6-address.h ns-3.41/src/network/utils/ipv6-address.h
--- ns-3.40/src/network/utils/ipv6-address.h	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/ipv6-address.h	2024-02-09 14:44:08.425794000 -0800
@@ -654,7 +654,7 @@
 inline bool
 operator==(const Ipv6Address& a, const Ipv6Address& b)
 {
-    return (!std::memcmp(a.m_address, b.m_address, 16));
+    return !std::memcmp(a.m_address, b.m_address, 16);
 }
 
 inline bool
@@ -666,13 +666,13 @@
 inline bool
 operator<(const Ipv6Address& a, const Ipv6Address& b)
 {
-    return (std::memcmp(a.m_address, b.m_address, 16) < 0);
+    return std::memcmp(a.m_address, b.m_address, 16) < 0;
 }
 
 inline bool
 operator==(const Ipv6Prefix& a, const Ipv6Prefix& b)
 {
-    return (!std::memcmp(a.m_prefix, b.m_prefix, 16));
+    return !std::memcmp(a.m_prefix, b.m_prefix, 16);
 }
 
 inline bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/mac16-address.cc ns-3.41/src/network/utils/mac16-address.cc
--- ns-3.40/src/network/utils/mac16-address.cc	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/mac16-address.cc	2024-02-09 14:44:08.425794000 -0800
@@ -35,73 +35,20 @@
 
 ATTRIBUTE_HELPER_CPP(Mac16Address);
 
-#define ASCII_a (0x41)
-#define ASCII_z (0x5a)
-#define ASCII_A (0x61)
-#define ASCII_Z (0x7a)
-#define ASCII_COLON (0x3a)
-#define ASCII_ZERO (0x30)
-
-/**
- * Converts a char to lower case.
- * \param c the char
- * \returns the lower case
- */
-static char
-AsciiToLowCase(char c)
-{
-    if (c >= ASCII_a && c <= ASCII_z)
-    {
-        return c;
-    }
-    else if (c >= ASCII_A && c <= ASCII_Z)
-    {
-        return c + (ASCII_a - ASCII_A);
-    }
-    else
-    {
-        return c;
-    }
-}
-
 uint64_t Mac16Address::m_allocationIndex = 0;
 
-Mac16Address::Mac16Address()
-{
-    NS_LOG_FUNCTION(this);
-    memset(m_address, 0, 2);
-}
-
 Mac16Address::Mac16Address(const char* str)
 {
     NS_LOG_FUNCTION(this << str);
-    int i = 0;
-    while (*str != 0 && i < 2)
-    {
-        uint8_t byte = 0;
-        while (*str != ASCII_COLON && *str != 0)
-        {
-            byte <<= 4;
-            char low = AsciiToLowCase(*str);
-            if (low >= ASCII_a)
-            {
-                byte |= low - ASCII_a + 10;
-            }
-            else
-            {
-                byte |= low - ASCII_ZERO;
-            }
-            str++;
-        }
-        m_address[i] = byte;
-        i++;
-        if (*str == 0)
-        {
-            break;
-        }
-        str++;
-    }
-    NS_ASSERT(i == 2);
+    NS_ASSERT_MSG(strlen(str) <= 5, "Mac16Address: illegal string (too long) " << str);
+
+    unsigned int bytes[2];
+    int charsRead = 0;
+
+    int i = sscanf(str, "%02x:%02x%n", bytes, bytes + 1, &charsRead);
+    NS_ASSERT_MSG(i == 2 && !str[charsRead], "Mac16Address: illegal string " << str);
+
+    std::copy(std::begin(bytes), std::end(bytes), std::begin(m_address));
 }
 
 Mac16Address::Mac16Address(uint16_t addr)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/mac16-address.h ns-3.41/src/network/utils/mac16-address.h
--- ns-3.40/src/network/utils/mac16-address.h	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/mac16-address.h	2024-02-09 14:44:08.425794000 -0800
@@ -43,10 +43,11 @@
 class Mac16Address
 {
   public:
-    Mac16Address();
+    Mac16Address() = default;
     /**
      * \param str a string representing the new Mac16Address
      *
+     * The format of the string is "xx:xx"
      */
     Mac16Address(const char* str);
 
@@ -228,7 +229,7 @@
     friend std::istream& operator>>(std::istream& is, Mac16Address& address);
 
     static uint64_t m_allocationIndex; //!< Address allocation index
-    uint8_t m_address[2];              //!< address value
+    uint8_t m_address[2]{0};           //!< Address value
 };
 
 ATTRIBUTE_HELPER_HEADER(Mac16Address);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/mac48-address.cc ns-3.41/src/network/utils/mac48-address.cc
--- ns-3.40/src/network/utils/mac48-address.cc	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/mac48-address.cc	2024-02-09 14:44:08.425794000 -0800
@@ -34,74 +34,28 @@
 
 ATTRIBUTE_HELPER_CPP(Mac48Address);
 
-#define ASCII_a (0x41)
-#define ASCII_z (0x5a)
-#define ASCII_A (0x61)
-#define ASCII_Z (0x7a)
-#define ASCII_COLON (0x3a)
-#define ASCII_ZERO (0x30)
-
-/**
- * Converts a char to lower case.
- * \param c the char
- * \returns the lower case
- */
-static char
-AsciiToLowCase(char c)
-{
-    NS_LOG_FUNCTION(c);
-    if (c >= ASCII_a && c <= ASCII_z)
-    {
-        return c;
-    }
-    else if (c >= ASCII_A && c <= ASCII_Z)
-    {
-        return c + (ASCII_a - ASCII_A);
-    }
-    else
-    {
-        return c;
-    }
-}
-
 uint64_t Mac48Address::m_allocationIndex = 0;
 
-Mac48Address::Mac48Address()
-{
-    NS_LOG_FUNCTION(this);
-    std::memset(m_address, 0, 6);
-}
-
 Mac48Address::Mac48Address(const char* str)
 {
     NS_LOG_FUNCTION(this << str);
-    int i = 0;
-    while (*str != 0 && i < 6)
-    {
-        uint8_t byte = 0;
-        while (*str != ASCII_COLON && *str != 0)
-        {
-            byte <<= 4;
-            char low = AsciiToLowCase(*str);
-            if (low >= ASCII_a)
-            {
-                byte |= low - ASCII_a + 10;
-            }
-            else
-            {
-                byte |= low - ASCII_ZERO;
-            }
-            str++;
-        }
-        m_address[i] = byte;
-        i++;
-        if (*str == 0)
-        {
-            break;
-        }
-        str++;
-    }
-    NS_ASSERT(i == 6);
+    NS_ASSERT_MSG(strlen(str) <= 17, "Mac48Address: illegal string (too long) " << str);
+
+    unsigned int bytes[6];
+    int charsRead = 0;
+
+    int i = sscanf(str,
+                   "%02x:%02x:%02x:%02x:%02x:%02x%n",
+                   bytes,
+                   bytes + 1,
+                   bytes + 2,
+                   bytes + 3,
+                   bytes + 4,
+                   bytes + 5,
+                   &charsRead);
+    NS_ASSERT_MSG(i == 6 && !str[charsRead], "Mac48Address: illegal string " << str);
+
+    std::copy(std::begin(bytes), std::end(bytes), std::begin(m_address));
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/mac48-address.h ns-3.41/src/network/utils/mac48-address.h
--- ns-3.40/src/network/utils/mac48-address.h	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/mac48-address.h	2024-02-09 14:44:08.425794000 -0800
@@ -45,7 +45,7 @@
 class Mac48Address
 {
   public:
-    Mac48Address();
+    Mac48Address() = default;
     /**
      * \param str a string representing the new Mac48Address
      *
@@ -213,7 +213,7 @@
     friend std::istream& operator>>(std::istream& is, Mac48Address& address);
 
     static uint64_t m_allocationIndex; //!< Address allocation index
-    uint8_t m_address[6];              //!< address value
+    uint8_t m_address[6]{0};           //!< Address value
 };
 
 ATTRIBUTE_HELPER_HEADER(Mac48Address);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/mac64-address.cc ns-3.41/src/network/utils/mac64-address.cc
--- ns-3.40/src/network/utils/mac64-address.cc	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/mac64-address.cc	2024-02-09 14:44:08.425794000 -0800
@@ -34,74 +34,30 @@
 
 ATTRIBUTE_HELPER_CPP(Mac64Address);
 
-#define ASCII_a (0x41)
-#define ASCII_z (0x5a)
-#define ASCII_A (0x61)
-#define ASCII_Z (0x7a)
-#define ASCII_COLON (0x3a)
-#define ASCII_ZERO (0x30)
-
-/**
- * Converts a char to lower case.
- * \param c the char
- * \returns the lower case
- */
-static char
-AsciiToLowCase(char c)
-{
-    NS_LOG_FUNCTION(c);
-    if (c >= ASCII_a && c <= ASCII_z)
-    {
-        return c;
-    }
-    else if (c >= ASCII_A && c <= ASCII_Z)
-    {
-        return c + (ASCII_a - ASCII_A);
-    }
-    else
-    {
-        return c;
-    }
-}
-
 uint64_t Mac64Address::m_allocationIndex = 0;
 
-Mac64Address::Mac64Address()
-{
-    NS_LOG_FUNCTION(this);
-    std::memset(m_address, 0, 8);
-}
-
 Mac64Address::Mac64Address(const char* str)
 {
     NS_LOG_FUNCTION(this << str);
-    int i = 0;
-    while (*str != 0 && i < 8)
-    {
-        uint8_t byte = 0;
-        while (*str != ASCII_COLON && *str != 0)
-        {
-            byte <<= 4;
-            char low = AsciiToLowCase(*str);
-            if (low >= ASCII_a)
-            {
-                byte |= low - ASCII_a + 10;
-            }
-            else
-            {
-                byte |= low - ASCII_ZERO;
-            }
-            str++;
-        }
-        m_address[i] = byte;
-        i++;
-        if (*str == 0)
-        {
-            break;
-        }
-        str++;
-    }
-    NS_ASSERT(i == 8);
+    NS_ASSERT_MSG(strlen(str) <= 23, "Mac64Address: illegal string (too long) " << str);
+
+    unsigned int bytes[8];
+    int charsRead = 0;
+
+    int i = sscanf(str,
+                   "%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x%n",
+                   bytes,
+                   bytes + 1,
+                   bytes + 2,
+                   bytes + 3,
+                   bytes + 4,
+                   bytes + 5,
+                   bytes + 6,
+                   bytes + 7,
+                   &charsRead);
+    NS_ASSERT_MSG(i == 8 && !str[charsRead], "Mac64Address: illegal string " << str);
+
+    std::copy(std::begin(bytes), std::end(bytes), std::begin(m_address));
 }
 
 Mac64Address::Mac64Address(uint64_t addr)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/mac64-address.h ns-3.41/src/network/utils/mac64-address.h
--- ns-3.40/src/network/utils/mac64-address.h	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/mac64-address.h	2024-02-09 14:44:08.425794000 -0800
@@ -45,7 +45,7 @@
 class Mac64Address
 {
   public:
-    Mac64Address();
+    Mac64Address() = default;
     /**
      * \param str a string representing the new Mac64Address
      *
@@ -180,7 +180,7 @@
     friend std::istream& operator>>(std::istream& is, Mac64Address& address);
 
     static uint64_t m_allocationIndex; //!< Address allocation index
-    uint8_t m_address[8];              //!< address value
+    uint8_t m_address[8]{0};           //!< Address value
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/mac8-address.cc ns-3.41/src/network/utils/mac8-address.cc
--- ns-3.40/src/network/utils/mac8-address.cc	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/mac8-address.cc	2024-02-09 14:44:08.425794000 -0800
@@ -30,11 +30,6 @@
 
 uint8_t Mac8Address::m_allocationIndex = 0;
 
-Mac8Address::Mac8Address()
-{
-    m_address = 255;
-}
-
 Mac8Address::Mac8Address(uint8_t addr)
     : m_address(addr)
 {
